package ucasEntities;

import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;

public class ApplicantBean {
	private long id;  // identifier
	private String passwd;
	private String surName;
	private String firstName;
	private String email;
	private boolean blacklisted=false;
	private Set<ExamResultBean> obtainedExamGrades = new HashSet<ExamResultBean>();
	private InstitutionBean appliedAt;
	private InstitutionBean acceptedAt;
	
	public ApplicantBean(){
		blacklisted=false;
	}
	
	public long getId() {
		return id;
	}
	public void setId(long id) {
		this.id = id;
	}
	public String getSurName() {
		return surName;
	}
	public void setSurName(String surName) {
		this.surName = surName;
	}
	public String getFirstName() {
		return firstName;
	}
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	public Set<ExamResultBean> getObtainedExamGrades() {
		return obtainedExamGrades;
	}
	public void setObtainedExamGrades(Set<ExamResultBean> obtainedExamGrades) {
		this.obtainedExamGrades = obtainedExamGrades;
	}
	public String getPasswd() {
		return passwd;
	}
	public void setPasswd(String passwd) {
		this.passwd = passwd;
	} 
 
	public String[] getSubjects(){
		String[] res=new String[obtainedExamGrades.size()];
		Iterator<ExamResultBean> iterator=obtainedExamGrades.iterator();
		for (int i=0;i<obtainedExamGrades.size();i++) {
			res[i] = iterator.next().getCourse();
		}
		return res;
	}
	
	public void setSubjects(String[] sub){
		ExamResultBean res;
		obtainedExamGrades.removeAll(obtainedExamGrades);
		for (int i=0;i<sub.length; i++){
			res=new ExamResultBean();
			res.setCourse(sub[i]);
			obtainedExamGrades.add(res);
		}
	}
	
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	

	
	public boolean hasResults() {
		boolean found=false;
		for (Iterator<ExamResultBean> i=obtainedExamGrades.iterator();i.hasNext();){
			String res=i.next().getResult();
			found=(found || res.length()>0);
		}
		return found;
	}

	public InstitutionBean getAppliedAt() {
		return appliedAt;
	}

	public void setAppliedAt(InstitutionBean appliedAt) {
		this.appliedAt = appliedAt;
	}

	public InstitutionBean getAcceptedAt() {
		return acceptedAt;
	}

	public void setAcceptedAt(InstitutionBean acceptedAt) {
		this.acceptedAt = acceptedAt;
	}

	public boolean isBlacklisted() {
		return blacklisted;
	}

	public void setBlacklisted(boolean blacklisted) {
		this.blacklisted = blacklisted;
	}
}
